<?php
//  =============================================================
//  2020 kaz PHP自動作成お助けTOOL. Start
//  修正BSDライセンス。
//  =============================================================
/* ディレクトリの定義 */

// BASE DIR
define('DIR_BASE', dirname(__FILE__) . '/../.php/');
// PEAR DIR
define('DIR_PEAR', DIR_BASE . 'pear/');
// TEMPLATE DIR
define('DIR_TEMPLATE', dirname(__FILE__) . '/templates/');
// Smarty DIR
define('DIR_SMARTY', DIR_BASE . 'smarty/');
//Smarty キャッシュ DIR
//define('DIR_COMPILE', DIR_BASE . 'compile/' );
define('DIR_COMPILE', dirname(__FILE__) . '/compile/');

// VIEW DIR
define('DIR_VIEW', dirname(__FILE__) . '/view/');
// LOG DIR
define('DIR_LOG', dirname(__FILE__) . '/log/');

// uploadした秘密にする画像ファイルを置くディレクトリ。
define('DIR_UPLOAD_SECRET',  dirname(__FILE__) . '/upload/');

// DOCUMENT_ROOT
define('DOCUMENT_ROOT', $_SERVER['DOCUMENT_ROOT']);
// uploadした画像ファイルを置くディレクトリ
define('DIR_UPLOAD', 'C:/xampp/htdocs/kaz/upload/');
define('DIR_UPLOAD_WEB', '/upload/');


/* include_path を set */

//$include_paths = explode(PATH_SEPARATOR, get_include_path());
$include_paths = array();
$include_paths[] = '.';
$include_paths[] = DIR_BASE;
$include_paths[] = DIR_PEAR;
$include_paths[] = DIR_SMARTY;

$include_paths[] = dirname(__FILE__) . '/';
$include_paths[] = dirname(__FILE__) . '/common/';


set_include_path(join(PATH_SEPARATOR, $include_paths));


/* Smartyを設定 */
require_once(DIR_SMARTY . 'Smarty.class.php');
$smarty = new Smarty();
$smarty->template_dir = DIR_TEMPLATE; // テンプレートファイルが存在するディレクトリ
$smarty->compile_dir = DIR_COMPILE; // テンプレートのキャッシュを作成するディレクトリ

$smarty->left_delimiter = '{{';
$smarty->right_delimiter = '}}';


/* ファイル読込 */ 

// 設定ファイル
require_once('config.php');
// 共通関数ファイル
require_once('functions.php');

//チェック関数ファイル
require_once('check_functions.php');

//ページングライブラリ
require_once('PageNavi.class.php');

// エラーハンドリング
// function userErrorHandler ($errno, $errmsg, $filename, $linenum) {
function userErrorHandler ($errno, $errmsg, $filename, $linenum) {	
    global $db;

    // エラー文字列の連想を定義
    // 実際に考慮するエントリは 2,8,256,512,1024のみ
    $errortype = array (
                1   =>  "Error",
                2   =>  "Warning",
                4   =>  "Parsing Error",
                8   =>  "Notice",
                16  =>  "Core Error",
                32  =>  "Core Warning",
                64  =>  "Compile Error",
                128 =>  "Compile Warning",
                256 =>  "User Error",
                512 =>  "User Warning",
                1024=>  "User Notice",
                2048=>  "Strict",
                4096=>  "Recoverable Error",
                8192=>  "Deprecated",
                16384=>  "User Deprecated"
                );

	echo 'The error occurred. ' . ' Errno: ' . $errno . ' Errortype: ' . 
	$errortype[$errno] . "<br />\n";
	// $fp = fopen(DIR_LOG . date('Ymd') . '_log.txt', 'a');
	// flock($fp, LOCK_EX);
	// fwrite($fp, 'Date: ' . date('Y/m/d H:i:s') . "\n");
	// fwrite($fp, 'Errno: ' . $errno . "\n");
	// fwrite($fp, 'Errortype: ' . $errortype[$errno] . "\n");
	// fwrite($fp, 'Message: ' . $errmsg . "\n");
	// fwrite($fp, 'Filename: ' . $filename . "\n");
	// fwrite($fp, 'Linenum: ' . $linenum . "\n");
	// fwrite($fp, "----------\n");
	// flock($fp, LOCK_UN);
	// fclose($fp);
    error_log('Date: ' . date('Y/m/d H:i:s') . "\n", 3, DIR_LOG . date('Ymd') . '_log.txt');
    error_log('Errno: ' . $errno . "\n", 3, DIR_LOG . date('Ymd') . '_log.txt');
    error_log('Errortype: ' . $errortype[$errno] . "\n", 3, DIR_LOG . date('Ymd') . '_log.txt');
    error_log('Message: ' . $errmsg . "\n", 3, DIR_LOG . date('Ymd') . '_log.txt');
    error_log('Filename: ' . $filename . "\n", 3, DIR_LOG . date('Ymd') . '_log.txt');
    error_log('Linenum: ' . $linenum . "\n", 3, DIR_LOG . date('Ymd') . '_log.txt');
    error_log("----------\n", 3, DIR_LOG . date('Ymd') . '_log.txt');
    
	if (!empty($db)) {
        if ($db->inTransaction()) {
            $db->rollBack();
        }
	}

	exit;
}
// 独自のエラー処理(E_NOTICE、E_DEPRECATEDE以外)を行う
error_reporting(E_ALL ^ E_NOTICE ^ E_DEPRECATED);
$old_error_handler = set_error_handler("userErrorHandler",  E_ALL ^ E_NOTICE ^ E_DEPRECATED);
//  =============================================================
//  2020 kaz PHP自動作成お助けTOOL. End
//  修正BSDライセンス。
//  =============================================================

?>