<?php
//  =============================================================
//  2020 kaz PHP自動作成お助けTOOL. Start
//  修正BSDライセンス。
//  =============================================================

// 大中小分類が一つになったエレメントをDBデータから作成するクラス
class AppDbCdUtil
{
    var $options = array(); // 大中小分類が一つになったエレメントをDBデータから作成するためのオプション

    var $ajaxKbn;       // ajax区分
    var $elementNm;     // ELEMENTS名称
    // 分類：省略不可
    var $lrgTblNm;      // 大分類テーブル名
    var $lrgTblAriasNm; // 大分類テーブルのエイリアス名
    var $lrgKey1Item;   // 大分類テーブルの大分類キー項目名
    var $lrgNmItem;     // 大分類テーブルの大分類日本語項目名
    var $lrgEngNmItem;  // 大分類テーブルの大分類英語項目名（大分類英語項目名がない場合null）
    var $lrgDelItem;    // 大分類テーブルの削除日項目名（削除日項目がない場合null）
    // 分類：省略可
    var $midTblNm;      // 中分類テーブル名
    var $midTblAriasNm; // 中分類テーブルのエイリアス名
    var $midKey1Item;   // 中分類テーブルの大分類キー項目名
    var $midKey2Item;   // 中分類テーブルの中分類キー項目名
    var $midNmItem;     // 中分類テーブルの中分類日本語項目名
    var $midEngNmItem;  // 中分類テーブルの中分類英語項目名（中分類英語項目名がない場合null）
    var $midDelItem;    // 中分類テーブルの削除日項目名（削除日項目がない場合null）
    // 分類：省略可
    var $smlTblNm;      // 小分類テーブル名
    var $smlTblAriasNm; // 小分類テーブルのエイリアス名
    var $smlKey1Item;   // 小分類テーブルの大分類キー項目名
    var $smlKey2Item;   // 小分類テーブルの中分類キー項目名
    var $smlKey3Item;   // 小分類テーブルの小分類キー項目名
    var $smlNmItem;     // 小分類テーブルの小分類日本語項目名
    var $smlEngNmItem;  // 小分類テーブルの小分類英語項目名（小分類英語項目名がない場合null）
    var $smlDelItem;    // 小分類テーブルの削除日項目名（削除日項目がない場合null）

    /**
     *　大中小分類が一つになったエレメントをDBデータから作成するためのオプション設定。
     *　中分類、小分類を省略できます。
     *  よって、大分類のみ、大分類＋中分類、大分類＋中分類＋小分類の3種類に対応できます。
     *  パラメータ：
     * @param  $ajaxKbn;      ：ajax区分
     * @param  $elementNm     ：ELEMENTS名称
     *   大分類：省略不可
     * @param  $lrgTblNm      ：大分類テーブル名
     * @param  $lrgTblAriasNm ：大分類テーブルのエイリアス名
     * @param  $lrgKey1Item   ：大分類テーブルの大分類キー項目名
     * @param  $lrgNmItem     ：大分類テーブルの大分類日本語項目名
     * @param  $lrgEngNmItem  ：大分類テーブルの大分類英語項目名（大分類英語項目名がない場合null）
     * @param  $lrgDelItem    ：大分類テーブルの削除日項目名（削除日項目がない場合null）
     *   中分類：省略可
     * @param  $midTblNm      ：中分類テーブル名
     * @param  $midTblAriasNm ：中分類テーブルのエイリアス名
     * @param  $midKey1Item   ：中分類テーブルの大分類キー項目名
     * @param  $midKey2Item   ：中分類テーブルの中分類キー項目名
     * @param  $midNmItem     ：中分類テーブルの中分類日本語項目名
     * @param  $midEngNmItem  ：中分類テーブルの中分類英語項目名（中分類英語項目名がない場合null）
     * @param  $midDelItem    ：中分類テーブルの削除日項目名（削除日項目がない場合null）
     *   小分類：省略可
     * @param  $smlTblNm      ：小分類テーブル名
     * @param  $smlTblAriasNm ：小分類テーブルのエイリアス名
     * @param  $smlKey1Item   ：小分類テーブルの大分類キー項目名
     * @param  $smlKey2Item   ：小分類テーブルの中分類キー項目名
     * @param  $smlKey3Item   ：小分類テーブルの小分類キー項目名
     * @param  $smlNmItem     ：小分類テーブルの小分類日本語項目名
     * @param  $smlEngNmItem  ：小分類テーブルの小分類英語項目名（小分類英語項目名がない場合null）
     * @param  $smlDelItem    ：小分類テーブルの削除日項目名（削除日項目がない場合null）
      */
    function setOptions($ajaxKbn, $elementNm, 
        $lrgTblNm, $lrgTblAriasNm, $lrgKey1Item, $lrgNmItem, $lrgEngNmItem, $lrgDelItem,
        $midTblNm=null, $midTblAriasNm=null, $midKey1Item=null, $midKey2Item=null, $midNmItem=null, $midEngNmItem=null, $midDelItem=null,
        $smlTblNm=null, $smlTblAriasNm=null, $smlKey1Item=null, $smlKey2Item=null, $smlKey3Item=null, $smlNmItem=null, $smlEngNmItem=null, $smlDelItem=null) {

        if (empty($this->options)) { // 
            $this->options = array(); 
        }
        $i = count($this->options) + 1; // オプション

        $this->options[$i]['ajaxKbn']       = $ajaxKbn;       // ajax区分
        $this->options[$i]['elementNm']     = $elementNm;     // ELEMENTS名称
        // 分類：省略不可
        $this->options[$i]['lrgTblNm']      = $lrgTblNm;      // 大分類テーブル名
        $this->options[$i]['lrgTblAriasNm'] = $lrgTblAriasNm; // 大分類テーブルのエイリアス名
        $this->options[$i]['lrgKey1Item']   = $lrgKey1Item;   // 大分類テーブルの大分類キー項目名
        $this->options[$i]['lrgNmItem']     = $lrgNmItem;     // 大分類テーブルの大分類日本語項目名
        $this->options[$i]['lrgEngNmItem']  = $lrgEngNmItem;  // 大分類テーブルの大分類英語項目名（大分類英語項目名がない場合null）
        $this->options[$i]['lrgDelItem']    = $lrgDelItem;    // 大分類テーブルの削除日項目名（削除日項目がない場合null）
        // 分類：省略可
        $this->options[$i]['midTblNm']      = $midTblNm;      // 中分類テーブル名
        $this->options[$i]['midTblAriasNm'] = $midTblAriasNm; // 中分類テーブルのエイリアス名
        $this->options[$i]['midKey1Item']   = $midKey1Item;   // 中分類テーブルの大分類キー項目名
        $this->options[$i]['midKey2Item']   = $midKey2Item;   // 中分類テーブルの中分類キー項目名
        $this->options[$i]['midNmItem']     = $midNmItem;     // 中分類テーブルの中分類日本語項目名
        $this->options[$i]['midEngNmItem']  = $midEngNmItem;  // 中分類テーブルの中分類英語項目名（中分類英語項目名がない場合null）
        $this->options[$i]['midDelItem']    = $midDelItem;    // 中分類テーブルの削除日項目名（削除日項目がない場合null）
        // 分類：省略可
        $this->options[$i]['smlTblNm']      = $smlTblNm;      // 小分類テーブル名
        $this->options[$i]['smlTblAriasNm'] = $smlTblAriasNm; // 小分類テーブルのエイリアス名
        $this->options[$i]['smlKey1Item']   = $smlKey1Item;   // 小分類テーブルの大分類キー項目名
        $this->options[$i]['smlKey2Item']   = $smlKey2Item;   // 小分類テーブルの中分類キー項目名
        $this->options[$i]['smlKey3Item']   = $smlKey3Item;   // 小分類テーブルの小分類キー項目名
        $this->options[$i]['smlNmItem']     = $smlNmItem;     // 小分類テーブルの小分類日本語項目名
        $this->options[$i]['smlEngNmItem']  = $smlEngNmItem;  // 小分類テーブルの小分類英語項目名（小分類英語項目名がない場合null）
        $this->options[$i]['smlDelItem']    = $smlDelItem;    // 小分類テーブルの削除日項目名（削除日項目がない場合null）

    }

    function clrOpts() {
        $this->ajaxKbn        = '';     // ajax区分
        $this->elementNm      = '';     // ELEMENTS名称
        // 分類：省略不可
        $this->lrgTblNm       = '';      // 大分類テーブル名
        $this->lrgTblAriasNm  = ''; // 大分類テーブルのエイリアス名
        $this->lrgKey1Item    = '';   // 大分類テーブルの大分類キー項目名
        $this->lrgNmItem      = '';     // 大分類テーブルの大分類日本語項目名
        $this->lrgEngNmItem   = '';  // 大分類テーブルの大分類英語項目名（大分類英語項目名がない場合null）
        $this->lrgDelItem     = '';    // 大分類テーブルの削除日項目名（削除日項目がない場合null）
        // 分類：省略可
        $this->midTblNm       = '';      // 中分類テーブル名
        $this->midTblAriasNm  = ''; // 中分類テーブルのエイリアス名
        $this->midKey1Item    = '';   // 中分類テーブルの大分類キー項目名
        $this->midKey2Item    = '';   // 中分類テーブルの中分類キー項目名
        $this->midNmItem      = '';     // 中分類テーブルの中分類日本語項目名
        $this->midEngNmItem   = '';  // 中分類テーブルの中分類英語項目名（中分類英語項目名がない場合null）
        $this->midDelItem     = '';    // 中分類テーブルの削除日項目名（削除日項目がない場合null）
        // 分類：省略可
        $this->smlTblNm       = '';      // 小分類テーブル名
        $this->smlTblAriasNm  = ''; // 小分類テーブルのエイリアス名
        $this->smlKey1Item    = '';   // 小分類テーブルの大分類キー項目名
        $this->smlKey2Item    = '';   // 小分類テーブルの中分類キー項目名
        $this->smlKey3Item    = '';   // 小分類テーブルの小分類キー項目名
        $this->smlNmItem      = '';     // 小分類テーブルの小分類日本語項目名
        $this->smlEngNmItem   = '';  // 小分類テーブルの小分類英語項目名（小分類英語項目名がない場合null）
        $this->smlDelItem     = '';    // 小分類テーブルの削除日項目名（削除日項目がない場合null）
    }

    function setOpts($opt) {
        $this->ajaxKbn        = $opt['ajaxKbn'];       // ajax区分
        $this->elementNm      = $opt['elementNm'];     // ELEMENTS名称
        // 分類：省略不可
        $this->lrgTblNm       = $opt['lrgTblNm'];      // 大分類テーブル名
        $this->lrgTblAriasNm  = $opt['lrgTblAriasNm']; // 大分類テーブルのエイリアス名
        $this->lrgKey1Item    = $opt['lrgKey1Item'];   // 大分類テーブルの大分類キー項目名
        $this->lrgNmItem      = $opt['lrgNmItem'];     // 大分類テーブルの大分類日本語項目名
        $this->lrgEngNmItem   = $opt['lrgEngNmItem'];  // 大分類テーブルの大分類英語項目名（大分類英語項目名がない場合null）
        $this->lrgDelItem     = $opt['lrgDelItem'];    // 大分類テーブルの削除日項目名（削除日項目がない場合null）
        // 分類：省略可
        $this->midTblNm       = $opt['midTblNm'];      // 中分類テーブル名
        $this->midTblAriasNm  = $opt['midTblAriasNm']; // 中分類テーブルのエイリアス名
        $this->midKey1Item    = $opt['midKey1Item'];   // 中分類テーブルの大分類キー項目名
        $this->midKey2Item    = $opt['midKey2Item'];   // 中分類テーブルの中分類キー項目名
        $this->midNmItem      = $opt['midNmItem'];     // 中分類テーブルの中分類日本語項目名
        $this->midEngNmItem   = $opt['midEngNmItem'];  // 中分類テーブルの中分類英語項目名（中分類英語項目名がない場合null）
        $this->midDelItem     = $opt['midDelItem'];    // 中分類テーブルの削除日項目名（削除日項目がない場合null）
        // 分類：省略可
        $this->smlTblNm       = $opt['smlTblNm'];      // 小分類テーブル名
        $this->smlTblAriasNm  = $opt['smlTblAriasNm']; // 小分類テーブルのエイリアス名
        $this->smlKey1Item    = $opt['smlKey1Item'];   // 小分類テーブルの大分類キー項目名
        $this->smlKey2Item    = $opt['smlKey2Item'];   // 小分類テーブルの中分類キー項目名
        $this->smlKey3Item    = $opt['smlKey3Item'];   // 小分類テーブルの小分類キー項目名
        $this->smlNmItem      = $opt['smlNmItem'];     // 小分類テーブルの小分類日本語項目名
        $this->smlEngNmItem   = $opt['smlEngNmItem'];  // 小分類テーブルの小分類英語項目名（小分類英語項目名がない場合null）
        $this->smlDelItem     = $opt['smlDelItem'];    // 小分類テーブルの削除日項目名（削除日項目がない場合null）
    }


    /**
     *  エレメントをajax経由で作成するか否かの配列を戻す。
     *  AppHtmlUtil.phpのcreJSvarAryLrgmidsmlAjaxKbnメソッドで使用する。
      */
    function getAryLrgmidsmlAjaxKbn() {
        $vals = array(); 
        foreach ($this->options as $opt ){
            $vals[$opt['elementNm']] = $opt['ajaxKbn']; // ELEMENTS名称、ajax区分
        }
        return $vals;
    }


    /**
     *　大中小分類が一つになったELEMENTSをDBデータから作成し戻す。
     *  結果：
     *     $lrgMidSmlAllKbnが'lrg'、'mid'、'sml'の場合、作成したエレメントを戻す。
     *     'lrg'、'mid'、'sml'以外は空配列を戻す。
     *     エレメントが$this->optionにないとき又は、「ajax区分」が'ajax'以外の時も空配列を戻す。
     *     戻すエレメントの内容は「function.php」の「creLrgMidSmlCategoryEleBase()」メソッド参照。
     * @param  $lrgMidSmlAllKbn 'lrg'、'mid'、'sml'
     * @param  $elementNm       ELEMENTS名称
     * @param  $lrgKey          大分類キー　指定しない場合''を設定
     * @param  $midKey          中分類キー　指定しない場合''を設定
     * @param  $smlKey          小分類キー　指定しない場合''を設定
      */
    function getLrgMidSmlElements ($lrgMidSmlAllKbn, $elementNm, $lrgKey, $midKey, $smlKey) {

        $elem = array();

        // $lrgMidSmlAllKbnが'lrg'、'mid'、'sml'以外は空配列を戻す。
        if ($lrgMidSmlAllKbn != 'lrg' && $lrgMidSmlAllKbn != 'mid' && $lrgMidSmlAllKbn != 'sml') {
            return $elem;
        }

        $this->clrOpts();
        foreach ($this->options as $opt ){
            if ($opt['elementNm'] == $elementNm) { // ELEMENTS名称が同じ
                $this->setOpts($opt);
                break;
            }
        }
        // エレメントが$this->optionにないとき又は、「ajax区分」が'ajax'以外のときは空配列を戻す。
        if ($this->elementNm == '' || $this->ajaxKbn != 'ajax') {
            return $elem;
        }
        $elem = & creLrgMidSmlCategoryEleBase($lrgMidSmlAllKbn, $lrgKey, $midKey, $smlKey,
        $this->elementNm, 
        $this->lrgTblNm, $this->lrgTblAriasNm, $this->lrgKey1Item, $this->lrgNmItem, $this->lrgEngNmItem, $this->lrgDelItem,
        $this->midTblNm, $this->midTblAriasNm, $this->midKey1Item, $this->midKey2Item, $this->midNmItem, $this->midEngNmItem, $this->midDelItem,
        $this->smlTblNm, $this->smlTblAriasNm, $this->smlKey1Item, $this->smlKey2Item, $this->smlKey3Item, $this->smlNmItem, $this->smlEngNmItem, $this->smlDelItem);
        return $elem;
    }

    /**
     *　大中小分類が一つになったELEMENTSをDBデータから＄ELEMENTSに直接設定する。
     *  結果：
     *  　$this->option中の「ajax区分」が''の時、作成したエレメントを＄ELEMENTSに直接設定する。
     *  　$this->option中の「ajax区分」が''以外の時は何もしない。
     *    戻すエレメントの内容は「function.php」の「creLrgMidSmlCategoryEleBase()」メソッド参照。
      */
    function creLrgMidSmlElements () {
        global $ELEMENTS;

        $this->clrOpts();
        foreach ($this->options as $opt ){ // 「ajax区分」が''
            if ($opt['ajaxKbn'] == '') {
                $this->setOpts($opt);
                $elem = & creLrgMidSmlCategoryEleBase('all', '', '', '',
                $this->elementNm, 
                $this->lrgTblNm, $this->lrgTblAriasNm, $this->lrgKey1Item, $this->lrgNmItem, $this->lrgEngNmItem, $this->lrgDelItem,
                $this->midTblNm, $this->midTblAriasNm, $this->midKey1Item, $this->midKey2Item, $this->midNmItem, $this->midEngNmItem, $this->midDelItem,
                $this->smlTblNm, $this->smlTblAriasNm, $this->smlKey1Item, $this->smlKey2Item, $this->smlKey3Item, $this->smlNmItem, $this->smlEngNmItem, $this->smlDelItem);
                $ELEMENTS[$this->elementNm] = & $elem[$this->elementNm];
            }
        }
    }



    /**
     *　大類類の$ELEMENTSを戻す。
     * @param  $elementNm       ELEMENTS名称
     * @param  $lrgKey          大分類キー　指定しない場合''を設定
      */
    function getLrgElements($elementNm, $lrgKey = '') {
        global $ELEMENTS,$AppDbCd;

        $elem = array();
        $this->clrOpts();
        foreach ($this->options as $opt ){
            if ($opt['elementNm'] == $elementNm) { // ELEMENTS名称が同じ
                $this->setOpts($opt);
                break;
            }
        }
        // エレメントが$this->optionにないとき又は、「ajax区分」が'ajax'のとき
        if ($this->elementNm != '' && $this->ajaxKbn == 'ajax') {
            $elem= $AppDbCd->getLrgMidSmlElements ('lrg', $elementNm, $lrgKey, '', '');
            $ELEMENTS[$elementNm]['lrg']= & $elem[$elementNm]['lrg'];
        }
        return $ELEMENTS[$elementNm];
    }

    /**
     *　中類類の$ELEMENTSを戻す。
     * @param  $elementNm       ELEMENTS名称
     * @param  $lrgKey          大分類キー　指定しない場合''を設定
     * @param  $midKey          中分類キー　指定しない場合''を設定
      */
    function getMidElements($elementNm, $lrgKey = '', $midKey = '') {
        global $ELEMENTS,$AppDbCd;

        $elem = array();
        $this->clrOpts();
        foreach ($this->options as $opt ){
            if ($opt['elementNm'] == $elementNm) { // ELEMENTS名称が同じ
                $this->setOpts($opt);
                break;
            }
        }
        // エレメントが$this->optionにないとき又は、「ajax区分」が'ajax'のとき
        if ($this->elementNm != '' && $this->ajaxKbn == 'ajax') {
            $elem= $AppDbCd->getLrgMidSmlElements ('mid', $elementNm, $lrgKey, $midKey, '');
            $ELEMENTS[$elementNm]['mid']= & $elem[$elementNm]['mid'];
        }
        return $ELEMENTS[$elementNm];
    }

    /**
     *　小類類の$ELEMENTSを戻す。
     * @param  $elementNm       ELEMENTS名称
     * @param  $lrgKey          大分類キー　指定しない場合''を設定
     * @param  $midKey          中分類キー　指定しない場合''を設定
     * @param  $smlKey          小分類キー　指定しない場合''を設定
      */
    function getSmlElements($elementNm, $lrgKey = '', $midKey = '', $smlKey = '') {
        global $ELEMENTS,$AppDbCd;

        $elem = array();
        $this->clrOpts();
        foreach ($this->options as $opt ){
            if ($opt['elementNm'] == $elementNm) { // ELEMENTS名称が同じ
                $this->setOpts($opt);
                break;
            }
        }
        // エレメントが$this->optionにないとき又は、「ajax区分」が'ajax'のとき
        if ($this->elementNm != '' && $this->ajaxKbn == 'ajax') {
            $elem= $AppDbCd->getLrgMidSmlElements ('sml', $elementNm, $lrgKey, $midKey, $smlKey);
            $ELEMENTS[$elementNm]['sml']= & $elem[$elementNm]['sml'];
        }
        return $ELEMENTS[$elementNm];
    }
    

    /**
     *　大類類の値を戻す。
     * @param  $elementNm       ELEMENTS名称
     * @param  $lrgKey          大分類キー
     * @param  $c_elements_idx  '0'日本語 '1'英語
      */
    function getLrgEleVal($elementNm, $lrgKey, $c_elements_idx) {
        global $ELEMENTS;
        $this->getLrgElements($elementNm, $lrgKey);
        return $ELEMENTS[$elementNm]['lrg'][$lrgKey][$c_elements_idx];
    }

    /**
     *　中類類の値を戻す。
     * @param  $elementNm       ELEMENTS名称
     * @param  $lrgKey          大分類キー
     * @param  $midKey          中分類キー
     * @param  $c_elements_idx  '0'日本語 '1'英語
      */
    function getMidEleVal($elementNm, $lrgKey, $midKey, $c_elements_idx) {
        global $ELEMENTS;
        $this->getMidElements($elementNm, $lrgKey, $midKey);
        return $ELEMENTS[$elementNm]['mid'][$lrgKey][$midKey][$c_elements_idx];
    }

    /**
     *　小類類の値を戻す。
     * @param  $elementNm       ELEMENTS名称
     * @param  $lrgKey          大分類キー
     * @param  $midKey          中分類キー
     * @param  $smlKey          小分類キー
     * @param  $c_elements_idx  '0'日本語 '1'英語
      */
    function getSmlEleVal($elementNm, $lrgKey, $midKey, $smlKey, $c_elements_idx) {
        global $ELEMENTS;
        $this->getSmlElements($elementNm, $lrgKey, $midKey, $smlKey);
        return $ELEMENTS[$elementNm]['sml'][$lrgKey][$midKey][$smlKey][$c_elements_idx];
    }
    
}



//  =============================================================
//  2020 kaz PHP自動作成お助けTOOL. End
//  修正BSDライセンス。
//  =============================================================

?>
