create database dbkaz character set utf8;
USE `dbkaz`;

drop table if exists `dbkaz`.`m_seq`;

CREATE TABLE `m_seq` (
  `table_id` varchar(50) NOT NULL,
  `up_date` date NOT NULL,
  `id` bigint NOT NULL,
  PRIMARY KEY  (`table_id`)
) ENGINE=InnoDB;

drop table if exists `dbkaz`.`m_logininfo`;

CREATE TABLE `m_logininfo` (
  `login_id` varchar(10) NOT NULL,
  `login_type` varchar(1) NOT NULL,
  `pwd1` varchar(16) NOT NULL,
  `yuko_flg` varchar(1) NOT NULL,
  `logininfo_insert` datetime NULL,
  `logininfo_update` datetime NULL,
  PRIMARY KEY  (`login_id`)
) ENGINE=InnoDB;

drop table if exists `dbkaz`.`m_user`;

CREATE TABLE `m_user` (
  `u_login_id` varchar(11) NOT NULL,
  `u_name` varchar(25) NOT NULL,
  `u_mail` varchar(50) NOT NULL,
  `u_pwd1` varchar(16) NOT NULL,
  `u_yuko_flg` varchar(1) NOT NULL,
  `u_insert` datetime NULL,
  `u_update` datetime NULL,
  PRIMARY KEY  (`u_login_id`)
) ENGINE=InnoDB;

drop table if exists `dbkaz`.`m_biztype`;

CREATE TABLE `m_biztype` (
  `biztype` bigint NOT NULL,
  `bizname` varchar(50) NOT NULL,
  `deldt` datetime NULL,
  `insdt` datetime NOT NULL,
  `updt` datetime NOT NULL,
  PRIMARY KEY  (`biztype`)
) ENGINE=InnoDB;

drop table if exists `dbkaz`.`t_corp`;

CREATE TABLE `t_corp` (
  `corpcd` varchar(11) NOT NULL,
  `corpnm` varchar(40) NOT NULL,
  `corpkn` varchar(80) NULL,
  `psno` varchar(8) NULL,
  `tdfknm` varchar(2) NOT NULL,
  `adrs1` varchar(40) NOT NULL,
  `adrs2` varchar(40) NULL,
  `map` varchar(50) NULL,
  `depart` varchar(40) NULL,
  `post` varchar(40) NULL,
  `tansei` varchar(40) NOT NULL,
  `tanmei` varchar(40) NOT NULL,
  `tanseijco` varchar(80) NULL,
  `tanmeijco` varchar(80) NULL,
  `telno` varchar(15) NOT NULL,
  `faxno` varchar(15) NULL,
  `mladrs` varchar(50) NULL,
  `biztype` bigint NOT NULL,
  `openkbn` varchar(1) NOT NULL,
  `deldt` datetime NULL,
  `insdt` datetime NOT NULL,
  `updt` datetime NOT NULL,
  PRIMARY KEY  (`corpcd`)
) ENGINE=InnoDB;

drop table if exists `dbkaz`.`m_shohin`;

CREATE TABLE `m_shohin` (
  `products` varchar(10) NOT NULL,
  `productsname` varchar(50) NULL,
  `biztype` bigint NULL,
  `category` varchar(10) NULL,
  `subcategory` varchar(10) NULL,
  `extracategory` varchar(10) NULL,
  `openkbn` varchar(1) NULL,
  `insdt` datetime NOT NULL,
  `updt` datetime NOT NULL,
  PRIMARY KEY  (`products`)
) ENGINE=InnoDB;

drop table if exists `dbkaz`.`t_item`;

CREATE TABLE `t_item` (
  `item01` varchar(11) NOT NULL,
  `item09` varchar(8) NULL,
  `item10` date NULL,
  `item11` date NULL,
  `item12` varchar(1) NOT NULL,
  `item13` varchar(1) NOT NULL,
  `item14` varchar(1) NULL,
  `item15` varchar(1) NULL,
  `item16` varchar(1) NOT NULL,
  `item17_1` varchar(3) NULL,
  `item17_2` varchar(4) NULL,
  `item19_1` varchar(10) NOT NULL,
  `item19_2` varchar(10) NULL,
  `item19_3` varchar(10) NOT NULL,
  `item22_1` varchar(10) NOT NULL,
  `item22_2` varchar(10) NOT NULL,
  `item22_3` varchar(10) NULL,
  `item26` varchar(100) NULL,
  `item27` varchar(10) NULL,
  `item28` varchar(10) NULL,
  `item29` varchar(10) NULL,
  `item30` varchar(10) NULL,
  `item31` varchar(10) NULL,
  `item32` varchar(10) NULL,
  `item33` varchar(10) NULL,
  `item34` varchar(10) NULL,
  `item35` varchar(10) NULL,
  `item36` varchar(10) NULL,
  `item37` varchar(10) NULL,
  `item38` varchar(10) NULL,
  `item39` varchar(10) NULL,
  `item40` varchar(10) NULL,
  `item41` varchar(10) NULL,
  `item42` varchar(50) NULL,
  `item43` varchar(10) NULL,
  `item44` varchar(15) NULL,
  `item45` varchar(10) NULL,
  `item46` varchar(10) NULL,
  `item47` varchar(10) NULL,
  `item48` varchar(10) NULL,
  `item49` varchar(10) NULL,
  `item50` varchar(10) NULL,
  `item51` varchar(10) NULL,
  `item52` varchar(10) NULL,
  `item53` datetime NULL,
  `item54` datetime NULL,
  `updt` datetime NOT NULL,
  PRIMARY KEY  (`item01`)
) ENGINE=InnoDB;

drop table if exists `dbkaz`.`m_category`;

CREATE TABLE `m_category` (
  `category` varchar(10) NOT NULL,
  `catname` varchar(50) NULL,
  `catengname` varchar(50) NULL,
  `deldt` datetime NULL,
  `insdt` datetime NOT NULL,
  `updt` datetime NOT NULL,
  PRIMARY KEY  (`category`)
) ENGINE=InnoDB;

drop table if exists `dbkaz`.`m_subcategory`;

CREATE TABLE `m_subcategory` (
  `category` varchar(10) NOT NULL,
  `subcategory` varchar(10) NOT NULL,
  `subcatname` varchar(50) NULL,
  `subcatengname` varchar(50) NULL,
  `deldt` datetime NULL,
  `insdt` datetime NOT NULL,
  `updt` datetime NOT NULL,
  PRIMARY KEY  (`category`,`subcategory`)
) ENGINE=InnoDB;

drop table if exists `dbkaz`.`m_extracategory`;

CREATE TABLE `m_extracategory` (
  `category` varchar(10) NOT NULL,
  `subcategory` varchar(10) NOT NULL,
  `extracategory` varchar(10) NOT NULL,
  `excatname` varchar(50) NULL,
  `excatengname` varchar(50) NULL,
  `deldt` datetime NULL,
  `insdt` datetime NOT NULL,
  `updt` datetime NOT NULL,
  PRIMARY KEY  (`category`,`subcategory`,`extracategory`)
) ENGINE=InnoDB;

drop table if exists `dbkaz`.`m_car`;

CREATE TABLE `m_car` (
  `corpcd` varchar(11) NOT NULL,
  `id` bigint NOT NULL,
  `carname` varchar(10) NOT NULL,
  `u_yuko_flg` varchar(1) NOT NULL,
  `insdt` datetime NOT NULL,
  `updt` datetime NOT NULL,
  PRIMARY KEY  (`corpcd`,`id`)
) ENGINE=InnoDB;

