<?php
//  =============================================================
//  2020 kaz PHP自動作成お助けTOOL. Start
//  修正BSDライセンス。
//  =============================================================
require_once('elements.php');

define('CON_CHK_ANY', 'ANY'); // 文字チェックなし
define('CON_CHK_HALF', 'HALF'); // 半角
define('CON_CHK_HALF_ANY', 'HALF_ANY'); // 半角文字チェックなし
define('CON_CHK_HALF_LETTER_DIGIT_KIGOU', 'HALF_LETTER_DIGIT_KIGOU'); // 半角英数字記号
define('CON_CHK_HALF_LETTER_DIGIT', 'HALF_LETTER_DIGIT'); // 半角英数字
define('CON_CHK_HALF_LETTER', 'HALF_LETTER'); // 半角英字
define('CON_CHK_HALF_LETTER_DIGIT_BIG', 'HALF_LETTER_DIGIT_BIG'); // 半角英数字大文字のみ
define('CON_CHK_HALF_LETTER_DIGIT_SMALL', 'HALF_LETTER_DIGIT_SMALL'); // 半角英数字小文字のみ
define('CON_CHK_HALF_LETTER_BIG', 'HALF_LETTER_BIG'); // 半角英字大文字のみ
define('CON_CHK_HALF_LETTER_SMALL', 'HALF_LETTER_SMALL'); // 半角英字小文字のみ
define('CON_CHK_HALF_KANA_DIGIT', 'HALF_KANA_DIGIT'); // 半角カタカナ数字
define('CON_CHK_HALF_DIGIT', 'HALF_DIGIT'); // 半角数字
define('CON_CHK_HALF_NUMBER', 'HALF_NUMBER'); // 半角数値（マイナスも入る）
define('CON_CHK_HALF_KANA', 'HALF_KANA'); // 半角カタカナ
define('CON_CHK_FULL', 'FULL'); // 全角
define('CON_CHK_FULL_KANA', 'FULL_KANA'); // 全角カタカナ
define('CON_CHK_FULL_HIRA', 'FULL_HIRA'); // 全角ひらがな
define('CON_CHK_EMAIL', 'EMAIL'); // メールアドレスの書式
define('CON_CHK_POST', 'POST'); // 郵便番号（nnn-nnnn）の書式
define('CON_CHK_TEL', 'TEL'); // 電話番号の書式

define('WIDTH_HALF', 256); // 全角・半角指定: 半角。
define('WIDTH_FULL', 512); // 全角・半角指定: 全角。
define('BIG', 1); // 大文字・小文字指定: 大文字。
define('SMALL', 2); // 大文字・小文字指定: 小文字。
	/*--------------------------------------------------------------------
	 * 以下の文字種類定数は OR , AND 演算を行うため、
	 * ２のＸ乗で定義する必要がある。 (TYPE_ANY は８ビットOnのため例外)。
	 *--------------------------------------------------------------------*/
define('TYPE_NUM'	, 1); // 文字種類指定: 数字。
define('TYPE_ALPHA', 2); // 文字種類指定: 英字。
define('TYPE_KATAKANA'	, 4); // 文字種類指定:カタカナ。
define('TYPE_HIRAKANA'	, 8); // 文字種類指定:ひらがな。
define('TYPE_KIGOU'	, 16); // 文字種類指定:記号。
define('TYPE_SP'	, 32); // 文字種類指定:半角空白。
define('TYPE_KANA'	, TYPE_KATAKANA + TYPE_HIRAKANA); // 文字種類指定: かな。
define('TYPE_ANY'	, 255); // 文字種類指定: すべての文字。
define('ERROR'	, -1); // 例外定数: エラー。
define('UNKNOWN'	, 0); // 例外定数: 不明。 typeOf() の仕様により 0 以外への変更は不可
define('PATTERN'	, "/^[a-z0-9_\\-\\.\\+\\!\\#\\$\\%\\&\\'\\*\\/\\=\\?\\^\\`\\{\\|\\}\\~]+@(([a-z0-9_]|\\-)+\\.)+[a-z]{2,6}$/i"); // メールアドレス正規表現


class AppCheckUtil
{

	
	/**
	 * 文字入力項目をチェックする。
	 * <br>
	 * @param  $vars       入力情報
	 * @param  $errorMessages     エラー情報
	 * @param  $typeNm      項目日本語名
     * @param  $result      エラーの有無情報
	 * @param  $data        項目ID
     * @param  $chkKind     チェック種類<br>
     *                      <ul>
     *						<li>ANY：文字チェックなし
     *						<li>HALF：半角
     *						<li>HALF_ANY：半角文字チェックなし
     *						<li>HALF_LETTER_DIGIT_KIGOU：半角英数字記号
     *						<li>HALF_LETTER_DIGIT：半角英数字
     *						<li>HALF_LETTER：半角英字
     *						<li>HALF_LETTER_DIGIT_BIG：半角英数字大文字のみ
     *						<li>HALF_LETTER_DIGIT_SMALL：半角英数字小文字のみ
     *						<li>HALF_LETTER_BIG：半角英字大文字のみ
     *						<li>HALF_LETTER_SMALL：半角英字小文字のみ
     *						<li>HALF_KANA_DIGIT：半角カタカナ数字
     *						<li>HALF_DIGIT：半角数字
     *						<li>HALF_KANA：半角カタカナ
     *						<li>FULL：全角
     *						<li>FULL_KANA：全角カタカナ
     *						<li>FULL_HIRA：全角ひらがな
     *						<li>EMAIL：メールアドレスの書式
     *						<li>POST：郵便番号（nnn-nnnn）の書式
     *						<li>TEL：電話番号の書式
     *                      </ul>
	 * @param  $length      文字数
     * @param  $kotei   　　桁固定の場合はtrueを渡す。以外はfalseを渡す。
　　 * @param  $inputCheck  未入力時にチェックをしない場合はfalseを渡す。チェックをする場合はtrueを渡す。
	 * @param  elementsIdx  0（日本語）,1（英語）を指定する。
	 * @param  trimflg      true(する),false(しない)を指定する。
     * @return boolean エラーの有無
 	 */
	 static function checkMoji(&$vars, &$errorMessages, $typeNm, $result,
							$data, $chkKind, $length, $kotei, $inputCheck, $elementsIdx = '0', $trimflg = true) {	
		if ($trimflg == true) {
			$vars[$data] = trim($vars[$data]);
		}
		// 未入力をエラーとするかしないかの切り分け（未入力時は処理終了）
		if ('' == $vars[$data] ) {
			if ($inputCheck == true) { // 未入力をチェック
				// ?を入力してください。
				if ($elementsIdx == '0') {
					$errorMessages[$data] = '『' . $typeNm . '』を入力してください。';
				} else {
					$errorMessages[$data] = 'Please input "' . $typeNm . '"';
				}
				return false;
			}
			return true;
		}
		$width = 0;
		$type  = 0;
		if (mb_substr($chkKind, 0, 4) == 'FULL') {
			$width = WIDTH_FULL;
		} else {
			$width = WIDTH_HALF;
		}

		if ($chkKind == CON_CHK_HALF) { // 半角
			$type = TYPE_NUM+TYPE_ALPHA+TYPE_KATAKANA+TYPE_KIGOU+TYPE_SP;
		}
		if ($chkKind == CON_CHK_HALF_LETTER_DIGIT_KIGOU) { // 半角英数字記号
			$type = TYPE_NUM+TYPE_ALPHA+TYPE_KIGOU+TYPE_SP;
		}
		if ($chkKind == CON_CHK_HALF_LETTER_DIGIT) { // 半角英数字
			$type = TYPE_NUM+TYPE_ALPHA;
		}
		if ($chkKind == CON_CHK_HALF_LETTER) { // 半角英字
			$type = TYPE_ALPHA;
		}
		if ($chkKind == CON_CHK_HALF_LETTER_DIGIT_BIG) { // 半角英数字大文字のみ
			$width += BIG;
			$type = TYPE_NUM+TYPE_ALPHA;
		}
		if ($chkKind == CON_CHK_HALF_LETTER_DIGIT_SMALL) { // 半角英数字小文字のみ
			$width += SMALL;
			$type = TYPE_NUM+TYPE_ALPHA;
		}
		if ($chkKind == CON_CHK_HALF_LETTER_BIG) { // 半角英字大文字のみ
			$width += BIG;
			$type = TYPE_ALPHA;
		}
		if ($chkKind == CON_CHK_HALF_LETTER_SMALL) { // 半角英字小文字のみ
			$width += SMALL;
			$type = TYPE_ALPHA;
		}
		if ($chkKind == CON_CHK_HALF_KANA_DIGIT) { // 半角カタカナ数字
			$type = TYPE_NUM+TYPE_KATAKANA+TYPE_SP;
		}
		if ($chkKind == CON_CHK_HALF_DIGIT) { // 半角数字
			$type = TYPE_NUM;
		}
		if ($chkKind == CON_CHK_HALF_KANA) { // 半角カタカナ
			$type = TYPE_KATAKANA+TYPE_SP;
		}
		if ($chkKind == CON_CHK_FULL) { // 全角
			$type = TYPE_ANY;
		}
		if ($chkKind == CON_CHK_FULL_KANA) { // 全角カタカナ
			$type = TYPE_KATAKANA;
		}
		if ($chkKind == CON_CHK_FULL_HIRA) { // 全角ひらがな
			$type = TYPE_HIRAKANA;
		}
		if ($chkKind == CON_CHK_EMAIL) { // メールアドレスの書式
			if (!preg_match(PATTERN, (string)$vars[$data]) ) {
				if ($elementsIdx == '0') {
					$errorMessages[$data] = 'メールアドレスの形式が正しくありません。';	
				} else {
					$errorMessages[$data] = 'Email is not correct.';	
				}
				return false;
			}
		} else if ($chkKind == CON_CHK_POST) { // 郵便番号（nnn-nnnn）の書式
			if (!preg_match('/^[0-9][0-9][0-9]\-[0-9][0-9][0-9][0-9]$/i', (string)$vars[$data]) ) {
				if ($elementsIdx == '0') {
					$errorMessages[$data] = '郵便番号（nnn-nnnn）の形式が正しくありません。';	
				} else {
					$errorMessages[$data] = 'ZIP code (nnn-nnnn) is not correct.';	
				}
				return false;
			}
		} else if ($chkKind == CON_CHK_TEL) { // 電話番号の書式
			//if (!preg_match("/\d{2,4}-\d{2,4}-\d{4}/", (string)$vars[$data]) ) {
			if (!preg_match("/^[0-9\-]*$/", (string)$vars[$data]) ) {
				if ($elementsIdx == '0') {
					$errorMessages[$data] = '電話番号の形式が正しくありません。';	
				} else {
					$errorMessages[$data] = 'the telephone number (numerical and hyphen) is not correct.';	
				}
				return false;
			}
		} else if ($chkKind == CON_CHK_HALF_NUMBER) { // 半角数値（マイナスも入る）の書式
			if (!preg_match('/^-?[0-9]+$/', (string)$vars[$data]) ) {
				if ($elementsIdx == '0') {
					$errorMessages[$data] = '『' . $typeNm . '』の文字種が違っています。';	
				} else {
					$errorMessages[$data] = 'The character kind is different. "' . $typeNm . '"';
				}
				return false;
			}
		} else if ($chkKind == CON_CHK_HALF_ANY) { // 半角文字チェックなし
			if (!AppCheckUtil::typeOf($vars[$data], WIDTH_HALF, TYPE_ANY)) {
				// 文字種が違っています。
				if ($elementsIdx == '0') {
					$errorMessages[$data] = '『' . $typeNm . '』の文字種が違っています。';
				} else {
					$errorMessages[$data] = 'The character kind is different. "' . $typeNm . '"';
				}
				return false;
			}
		} else if ($chkKind != CON_CHK_ANY  && !AppCheckUtil::typeOf($vars[$data], $width, $type)) {
			// 文字種が違っています。
			if ($elementsIdx == '0') {
				$errorMessages[$data] = '『' . $typeNm . '』の文字種が違っています。';
			} else {
				$errorMessages[$data] = 'The character kind is different. "' . $typeNm . '"';
			}
			return false;
		}

		if (mb_strlen($vars[$data], 'UTF-8') >  $length ) {
			if ($kotei == false) {
				// 文字数は?文字以内で入力してください。
				if ($elementsIdx == '0') {
					$errorMessages[$data] = '『' . $typeNm . '』の文字数は' . $length . '文字以内で入力してください。';
				} else {
					$errorMessages[$data] = 'Please input it within ' . $length . ' characters. "' . $typeNm . '"';
				}
				return false;
			} else {
				// 文字数は?で入力してください。
				if ($elementsIdx == '0') {
					$errorMessages[$data] = '『' . $typeNm . '』の文字数は' . $length . 'で入力してください。';
				} else {
					$errorMessages[$data] = 'Please input it by  ' . $length . ' characters. "' . $typeNm . '"』';
				}
				return false;
			}
		} else if (mb_strlen($vars[$data], 'UTF-8') !=  $length && $kotei == true) {
			// 文字数は?で入力してください。
			if ($elementsIdx == '0') {
				$errorMessages[$data] = '『' . $typeNm . '』の文字数は' . $length . 'で入力してください。';
			} else {
				$errorMessages[$data] = 'Please input it by  ' . $length . ' characters. "' . $typeNm . '"';
			}
			return false;
		}
		return true;
	}


	static function checkDate(&$vars, &$errorMessages, $typeNm, $result,
							$data, $inputCheck, $elementsIdx = '0') {	
		// 未入力をエラーとするかしないかの切り分け（未入力時は処理終了）
		if ('' == $vars[$data] ) {
			if ($inputCheck == true) { // 未入力をチェック
				// ?を入力してください。
				if ($elementsIdx == '0') {
					$errorMessages[$data] = '『' . $typeNm . '』を入力してください。';
				} else {
					$errorMessages[$data] = 'Please input "' . $typeNm . '"';
				}
				return false;
			}
			return true;
		}

		$ary = explode('/', $vars[$data], 3);
		$temp = array();
		$temp[$data] =  $ary[0] .  $ary[1].  $ary[2];
		if ($ary[0] == '' ||  $ary[1] == '' || $ary[2] == '' || mb_strlen($ary[0]) != 4 || 
				!AppCheckUtil::checkMoji($temp, $errorMessages, $typeNm, $result,
						$data, CON_CHK_HALF_DIGIT, 10, false, false, $elementsIdx)) {
			// 日付を入力してください。
			if ($elementsIdx == '0') {
				$errorMessages[$data] = '『' . $typeNm . '』は日付を入力してください。';
			} else {
				$errorMessages[$data] = 'Please input Date Format "' . $typeNm . '"';
			}
			return false;
		}
		if (!checkdate($ary[1], $ary[2], $ary[0])) { 
			// 日付を入力してください。
			if ($elementsIdx == '0') {
				$errorMessages[$data] = '『' . $typeNm . '』は日付を入力してください。';
			} else {
				$errorMessages[$data] = 'Please input Date Format "' . $typeNm . '"';
			}
			return false;
		}


		if (''!= $vars[$data]) {
			$vars[$data] = sprintf("%04d", $ary[0]) . 
										'/' . sprintf("%02d", $ary[1]) . 
										'/' . sprintf("%02d", $ary[2]);
		}
		return true;
	}

	static function checkDateFromTo(&$vars, &$errorMessages, $typeNm, $result,
							$dataFrom, $dataTo, $elementsIdx = '0') {	

		$dateNm = mb_substr($dataFrom,0, mb_strlen($dataFrom) - 5);
		if ('' != $vars[$dataFrom] ) {

			$ary = explode('/', $vars[$dataFrom], 3);
			$temp = array();
			$temp[$dataFrom] =  $ary[0] .  $ary[1].  $ary[2];
			if ($ary[0] == '' ||  $ary[1] == '' || $ary[2] == '' || mb_strlen($ary[0]) != 4 || 
					!AppCheckUtil::checkMoji($temp, $errorMessages, $typeNm, $result,
							$dataFrom, CON_CHK_HALF_DIGIT, 10, false, false, $elementsIdx)) {
				// 日付を入力してください。
				if ($elementsIdx == '0') {
					$errorMessages[$dateNm] = '『' . $typeNm . ' From』は日付を入力してください。';
				} else {
					$errorMessages[$dateNm] = 'Please input Date Format "' . $typeNm . ' From"';
				}
				return false;
			}
			if (!checkdate($ary[1], $ary[2], $ary[0])) { 
				// 日付を入力してください。
				if ($elementsIdx == '0') {
					$errorMessages[$dateNm] = '『' . $typeNm . ' From』は日付を入力してください。';
				} else {
					$errorMessages[$dateNm] = 'Please input Date Format "' . $typeNm . ' From"';
				}
				return false;
			}
		}

		if ('' != $vars[$dataTo] ) {
			$ary = explode('/', $vars[$dataTo], 3);
			$temp = array();
			$temp[$dataTo] =  $ary[0] .  $ary[1].  $ary[2];
			if ($ary[0] == '' ||  $ary[1] == '' || $ary[2] == '' || mb_strlen($ary[0]) != 4 || 
					!AppCheckUtil::checkMoji($temp, $errorMessages, $typeNm, $result,
							$dataTo, CON_CHK_HALF_DIGIT, 10, false, false, $elementsIdx)) {
				// 日付を入力してください。
				if ($elementsIdx == '0') {
					$errorMessages[$dateNm] = '『' . $typeNm . ' To』は日付を入力してください。';
				} else {
					$errorMessages[$dateNm] = 'Please input Date Format "' . $typeNm . ' To"';
				}
				return false;
			}
			if (!checkdate($ary[1], $ary[2], $ary[0])) { 
				// 日付を入力してください。	
				if ($elementsIdx == '0') {
					$errorMessages[$dateNm] = '『' . $typeNm . ' To』は日付を入力してください。';
				} else {
					$errorMessages[$dateNm] = 'Please input Date Format "' . $typeNm . ' To"';
				}
				return false;
			}
		}

		if (''!= $vars[$dataFrom]) {
			$ary = explode('/', $vars[$dataFrom], 3);
			$vars[$dataFrom] = sprintf("%04d", $ary[0]) . 
										'/' . sprintf("%02d", $ary[1]) . 
										'/' . sprintf("%02d", $ary[2]);
		}

		if (''!= $vars[$dataTo]) {
			$ary = explode('/', $vars[$dataTo], 3);
			$vars[$dataTo] = sprintf("%04d", $ary[0]) . 
										'/' . sprintf("%02d", $ary[1]) . 
										'/' . sprintf("%02d", $ary[2]);
		}

		if (''!= $vars[$dataFrom] && ''!= $vars[$dataTo] && $vars[$dataFrom] > $vars[$dataTo]) {
			// 日付From <= 日付Toで入力してください。
			if ($elementsIdx == '0') {
				$errorMessages[$dateNm] = '『' . $typeNm . '』は日付From <= 日付Toで入力してください。';
			} else {
				$errorMessages[$dateNm] = 'Please input FromDate <= ToDate"' . $typeNm . '"';
			}
			return false;
		}
		
		return true;
	}

	static function checkStringCompareTo(&$vars, &$errorMessages, $typeNm, $result,
							$dataFrom, $dataTo, $elementsIdx = '0') {	

		if (''!= $vars[$dataFrom] && ''!= $vars[$dataTo] && $vars[$dataFrom] > $vars[$dataTo]) {
			// From <= Toで入力してください。
			if ($elementsIdx == '0') {
				$errorMessages[$dataFrom] = '『' . $typeNm . '』はFrom <= Toで入力してください。';
			} else {
				$errorMessages[$dataFrom] = 'Please input From <= To "' . $typeNm . '"';
			}
			return false;
		}
		
		return true;
	}

	static function checkNumericCompareTo(&$vars, &$errorMessages, $typeNm, $result,
							$dataFrom, $dataTo, $elementsIdx = '0') {	

		if (''!= $vars[$dataFrom] && ''!= $vars[$dataTo] && $vars[$dataFrom]+0 > $vars[$dataTo]+0) {
			// From <= Toで入力してください。
			if ($elementsIdx == '0') {
				$errorMessages[$dataFrom] = '『' . $typeNm . '』はFrom <= Toで入力してください。';
			} else {
				$errorMessages[$dataFrom] = 'Please input From <= To "' . $typeNm . '"';
			}
			return false;
		}
		
		return true;
	}

	static function checkCodeValue(&$vars, &$errorMessages, $typeNm, $result,
							$data, $codeName, $inputCheck, $elementsIdx = '0') {
		global $ELEMENTS;

		// 配列は検索のチェックボックスでしか使わないのでチェックしない。
		if (!empty($vars[$data]) && is_array($vars[$data])) { 
			return $result;
		}

		// 未入力をエラーとするかしないかの切り分け（未入力時は処理終了）
		if ('' ==  arryVal($vars, $data) ) {
			if ($inputCheck == true) { // 未入力をチェック
				// ?を入力してください。
				if ($elementsIdx == '0') {
					$errorMessages[$data] = '『' . $typeNm . '』を入力してください。';
				} else {
					$errorMessages[$data] = 'Please input "' . $typeNm . '"';
				}
				return false;
			}
			return true;
		}

		if (isset($ELEMENTS[$codeName][$vars[$data]])) {
			return $result;
		}
		// コード値がない場合
		if ($elementsIdx == '0') {
			$errorMessages[$data] = '『' . $typeNm . '』の入力形式に誤りがあります。';
		} else {
			$errorMessages[$data] = 'The mistake is found in the input form of the "' . $typeNm . '".';
		}
		return false;
	}

	static function checkNumeric(&$vars, &$errorMessages, $typeNm, $result,
							$data, $min, $max, $inputCheck, $elementsIdx = '0') {	
		$vars[$data] = trim($vars[$data]);
		// 未入力をエラーとするかしないかの切り分け（未入力時は処理終了）
		if ('' == $vars[$data] ) {
			if ($inputCheck == true) { // 未入力をチェック
				// ?を入力してください。
				if ($elementsIdx == '0') {
					$errorMessages[$data] = '『' . $typeNm . '』を入力してください。';
				} else {
					$errorMessages[$data] = 'Please input "' . $typeNm . '"';
				}
				return false;
			}
			return true;
		}
		if (!preg_match('/^-?[0-9]+$/', (string)$vars[$data]) ) {
			if ($elementsIdx == '0') {
				$errorMessages[$data] = '『' . $typeNm . '』の文字種が違っています。';	
			} else {
				$errorMessages[$data] = 'The character kind is different. "' . $typeNm . '"';
			}
			return false;
		} else {
			if ((($vars[$data] + 0) < ($min + 0)) || (($vars[$data] + 0) > ($max + 0))) {
				if ($elementsIdx == '0') {
					$errorMessages[$data] = '『' . $typeNm . '』の数値範囲に入っていません。';	
				} else {
					$errorMessages[$data] = 'Not in the range of numbers. "' . $typeNm . '"';
				}
				return false;
			}
		}
		return true;
	}

	static function checkDotNumeric(&$vars, &$errorMessages, $typeNm, $result,
							$data, $min, $max, $up, $down, $inputCheck, $elementsIdx = '0') {	
		$vars[$data] = trim($vars[$data]);
		// 未入力をエラーとするかしないかの切り分け（未入力時は処理終了）
		if ('' == $vars[$data] ) {
			if ($inputCheck == true) { // 未入力をチェック
				// ?を入力してください。
				if ($elementsIdx == '0') {
					$errorMessages[$data] = '『' . $typeNm . '』を入力してください。';
				} else {
					$errorMessages[$data] = 'Please input "' . $typeNm . '"';
				}
				return false;
			}
			return true;
		}
		if (!preg_match('/^-?([0-9]+)(.?)([0-9]*)$/', (string)$vars[$data], $matches )) {
			if ($elementsIdx == '0') {
				$errorMessages[$data] = '『' . $typeNm . '』の文字種が違っています。';	
			} else {
				$errorMessages[$data] = 'The character kind is different. "' . $typeNm . '"';
			}
			return false;
		} else {
			if ((($vars[$data] + 0) < ($min + 0)) || (($vars[$data] + 0) > ($max + 0))) {
				if ($elementsIdx == '0') {
					$errorMessages[$data] = '『' . $typeNm . '』の数値範囲に入っていません。';	
				} else {
					$errorMessages[$data] = 'Not in the range of numbers. "' . $typeNm . '"';
				}
				return false;
			} else {
				if (strlen($matches[2]) == 0) { // 小数点がない場合
					if (strlen($matches[1]) > $up) { // 整数部
						if ($elementsIdx == '0') {
							$errorMessages[$data] = '『' . $typeNm . '』の整数部桁数が違っています。';	
						} else {
							$errorMessages[$data] = 'Different from the integer digits. "' . $typeNm . '"';
						}
						return false;
					}
				} else { // 小数点がある場合
					if (strlen($matches[1]) > $up || strlen($matches[1]) == 0) {
						if ($elementsIdx == '0') {
							$errorMessages[$data] = '『' . $typeNm . '』の整数部桁数が違っています。';	
						} else {
							$errorMessages[$data] = 'Different from the integer digits. "' . $typeNm . '"';
						}
						return false;
					}
					if (strlen($matches[3]) > $down || strlen($matches[3]) == 0) {
						if ($elementsIdx == '0') {
							$errorMessages[$data] = '『' . $typeNm . '』の小数部桁数が違っています。';	
						} else {
							$errorMessages[$data] = 'Different from the number of decimal places. "' . $typeNm . '"';
						}
						return false;
					}
				}
			}
		}
		return true;
	}


	/**
	 * 指定された文字列が、引数で指定した文字種と一致するかを検査する。<br>
	 * <pre>
	 * 　　全角・半角の指定は以下の定数で指定する。
	 * 　　　半角：WIDTH_HALF
	 * 　　　全角：WIDTH_FULL
	 * 　
	 * 　　文字列種別の指定は以下の定数で指定する。
	 * 　　　数字　　　　：TYPE_NUM
	 * 　　　英字　　　　：TYPE_ALPHA
	 * 　　　カタカナ　　：TYPE_KATAKANA
	 * 　　　ひらがな　　：TYPE_HIRAKANA
	 * 　　　かな　　　　：TYPE_KANA
	 * 　　　すべての文字：TYPE_ANY
	 * </pre>
	 * 
	 * 文字列種別は種別の組み合わせで指定ができる。<br>
	 * 例えば、数字または英字であれば一致とみなす場合、以下のように定数の加算で指定する。<br>
	 * <br>
	 * 　　type_NUM + type_ALPHA<br>
	 *
	 * @param	$targetString	検査する文字列
	 * @param	$width			全角・半角の指定
	 * @param	$type			文字列種別の指定
	 * @return					検査結果
	 */
	static function typeOf($targetString, $width, $type) {

		// 文字列長チェック
		if(mb_strwidth($targetString) == 0){
			return false;
		}
		$bigSmall = 0; // 大文字小文字無し
		if ($width != WIDTH_FULL && $width != WIDTH_HALF) {
			if ($width > WIDTH_FULL) {
				$bigSmall = $width - WIDTH_FULL;
				$width = WIDTH_FULL;
			} else if ($width > WIDTH_HALF) {
				$bigSmall = $width - WIDTH_HALF;
				$width = WIDTH_HALF;
			}
		}

		// 文字幅（全角・半角）を検査
//		if(AppCheckUtil::getStringwidth($targetString) != $width ){
		if(AppCheckUtil::getStringwidth(preg_replace("/\r\n|\n/", "", $targetString)) != $width ){
			return false;
		}
		
		// 文字種を検査
		if( $type == TYPE_ANY ){
			// 文字種が何でもよければ true でリターン
			return true;
		}
		
		// 文字列長分繰り返し
        $targetLen = mb_strlen($targetString, "UTF-8");
        for($i = 0; $i < $targetLen; $i++){

			// 各文字の文字種を取得
			$moji = mb_substr($targetString, $i, 1, "UTF-8");
			$chartype = AppCheckUtil::getChartype(mb_substr($targetString, $i, 1, "UTF-8"));

			
			// 文字種判定
			
			if( ((int)$chartype & $type) == 0 ){
				return false;
			}
			if (WIDTH_HALF == $width) { // 半角のみ大文字小文字のチェックを行う。
				if (BIG == $bigSmall) { // 大文字
					if('a' <= $moji && $moji <= 'z'){
						return false;
					}
				} else if (SMALL == $bigSmall) { // 小文字
					if('A' <= $moji && $moji <= 'Z'){
						return false;
					}
				}
			}

		}
		
		return true;
	}


	/**
	 * 指定された文字の文字種を取得する。<br>
	 * <pre>
	 * 返却される値は以下の定数値
	 * 　
	 * 　　数字　　　　：TYPE_NUM
	 * 　　英字　　　　：TYPE_ALPHA
	 * 　　カタカナ　　：TYPE_KATAKANA
	 * 　　ひらがな　　：TYPE_HIRAKANA
	 * 　　かな　　　　：TYPE_KANA
	 * 　　半角空白　　：TYPE_SP
	 * 　　全角空白　　：TYPE_ZENSP
	 * 　　不明：UNKNOWN
	 * </pre>
	 * 
	 * @param	$target	検査する文字
	 * @return			文字種を表す定数
	 */
	static function getCharType($target) {

		if		('A'      <= $target && $target <= 'Z'     ){		return TYPE_ALPHA;	// 半角英字大文字
		}else if('a'      <= $target && $target <= 'z'     ){		return TYPE_ALPHA;	// 半角英字小文字
		}else if('0'      <= $target && $target <= '9'     ){		return TYPE_NUM;		// 半角数字
		}else if('ｦ' <= $target && $target <= 'ﾟ'){		return TYPE_KATAKANA;// その他半角（カタカナ）
		}else if('Ａ'     <= $target && $target <= 'Ｚ'    ){		return TYPE_ALPHA;	// 全角英字大文字
		}else if('ａ'     <= $target && $target <= 'ｚ'    ){		return TYPE_ALPHA;	// 全角英字小文字
		}else if('０'     <= $target && $target <= '９'    ){		return TYPE_NUM;		// 全角数字
	    }else if('　' == $target){							return TYPE_KANA;	// かな(カタカナ＋ひらがな)
		}else if('ー' == $target){							return TYPE_KANA;	// かな(カタカナ＋ひらがな)
		}else if('あ' <= $target && $target <= 'ん'){		return TYPE_HIRAKANA;// 日本語ひらがな
	    }else if('ァ' <= $target && $target <= 'ヶ'){     return TYPE_KATAKANA;// 日本語カタカナ
	    }else if(' ' == $target){							return TYPE_SP;// 半角空白
	    }else if('!'      <= $target && $target <= '/'){     return TYPE_KIGOU;// 半角記号
	    }else if(':'      <= $target && $target <= '@'){     return TYPE_KIGOU;// 半角記号
	    }else if('['      <= $target && $target <= '`'){     return TYPE_KIGOU;// 半角記号
	    }else if('{'      <= $target && $target <= '~'){     return TYPE_KIGOU;// 半角記号
		}else{													return UNKNOWN;		// 不明
		}
	}


	/**
	 * 指定された文字列が全角または半角のどちらで構成されているかを判断する。<br>
	 * <pre>
	 * 返却される値は以下の定数値
	 * 　
	 * 　　半角　：WIDTH_HALF
	 * 　　全角　：WIDTH_FULL
	 * 　　不明　：UNKNOWN
	 * 　　エラー：ERROR（指定文字列がnullや""の場合）
	 * </pre>
	 *
	 * @param	$targetString	検査する文字列
	 * @return					全角、半角を表す定数
	 */
	static function getStringWidth($targetString){

		// 引数チェック
		if(mb_strwidth($targetString) == 0){
			return ERROR;
		}
		
		$byteLen = strlen(mb_convert_encoding($targetString,"SJIS-WIN","UTF-8"));
		$mojiLen = mb_strlen(mb_convert_encoding($targetString,"SJIS-WIN","UTF-8"), 'SJIS-WIN');
		
		if($byteLen == $mojiLen){				// 半角

			return WIDTH_HALF;

		}else if( ($mojiLen*2) == $byteLen ){	// 全角

			return WIDTH_FULL;

		}else{								// それ以外は不明

			return UNKNOWN;
		}
	}

	static function checkPhoto(&$errorMessages, $typeNm, $result,
							$data, $inputCheck, $elementsIdx = '0', $exts = array( "jpg", "jpeg", "gif", "png" )) {	
		// 未入力をエラーとするかしないかの切り分け（未入力時は処理終了）
		if (empty($_FILES[$data]['name'])) {
			if ($inputCheck == true ) { // 未入力をチェック
				if (arryVal($_REQUEST, 'old_' . $data) == '') {
					// ?を入力してください。
					if ($elementsIdx == '0') {
						$errorMessages[$data] = '『' . $typeNm . '』を入力してください。';
					} else {
						$errorMessages[$data] = 'Please input "' . $typeNm . '"';
					}
					return false;
				} else {
					return $result;
				}
			}
			return $result;
		}
		chkExtension( $_FILES[$data]['name'], $exts, $errorMessages[$data] );
		if (''!= $errorMessages[$data]) {
			return false;
		}
		return $result;
	}

	// 初期UPLOAD時のファイル名チェック
	static function checkIUPPhoto(&$vars, &$errorMessages, $typeNm, $result,
							$data, $inputCheck, $elementsIdx = '0', $exts = array( "jpg", "jpeg", "gif", "png" )) {	
        // 未入力をエラーとするかしないかの切り分け（未入力時は処理終了）
        if (empty($vars[$data])) {
            if ($inputCheck == true ) { // 未入力をチェック
                // ?を入力してください。
                if ($elementsIdx == '0') {
                    $errorMessages[$data] = '『' . $typeNm . '』を入力してください。';
                } else {
                    $errorMessages[$data] = 'Please input "' . $data . '"';
                }
                return false;
            }
            return $result;
        }
        if (mb_strlen($data) < mb_strlen($vars[$data])) {
            if (($data . '.') != mb_substr($vars[$data], 0, mb_strlen($data)+1)) {
                if ($elementsIdx == '0') {
                    $errorMessages[$data] = '『' . $typeNm . '』のファイル名は『' . $data . '.』で始めてください。';
                } else {
                    $errorMessages[$data] = 'Please input "' . $data . '"file name start "' . $data . '."';
                }
                return false;
            }
        } else {
            if ($elementsIdx == '0') {
                $errorMessages[$data] = '『' . $typeNm . '』のファイル名は『' . $data . '.』で始めてください。';
            } else {
                $errorMessages[$data] = 'Please input "' . $data . '"file name start "' . $data . '."';
            }
            return false;
        }

		chkExtension( $vars[$data], $exts, $errorMessages[$data] );
		if (''!= $errorMessages[$data]) {
			return false;
		}
		return $result;
	}


	static function checkDateTime(&$vars, &$errorMessages, $typeNm, $result,
							$data, $inputCheck, $elementsIdx = '0') {	
		$vars[$data] = trim($vars[$data]);
		// 未入力をエラーとするかしないかの切り分け（未入力時は処理終了）
		if ('' == $vars[$data] ) {
			if ($inputCheck == true) { // 未入力をチェック
				// ?を入力してください。
				if ($elementsIdx == '0') {
					$errorMessages[$data] = '『' . $typeNm . '』を入力してください。';
				} else {
					$errorMessages[$data] = 'Please input "' . $typeNm . '"';
				}
				return false;
			}
			$vars[$data] = '0000/00/00 00:00:00';
			return true;
		} else if ('0000/00/00 00:00:00' == $vars[$data] ) {
			return true;
		}

		$aryA = explode(' ', $vars[$data], 2);
		if ($aryA[0] == '' ||  $aryA[1] == '' || mb_strlen($aryA[0]) != 10 || 
														mb_strlen($aryA[1]) != 8) {
			// 日付時間を入力してください。
			if ($elementsIdx == '0') {
				$errorMessages[$data] = '『' . $typeNm . '』は日付時間を入力してください。';
			} else {
				$errorMessages[$data] = 'Please input DateTime Format "' . $typeNm . '"';
			}
			return false;
		}
		// 日付をチェック
		$ary = explode('/', $aryA[0], 3);
		$temp = array();
		$temp[$data] =  $ary[0] .  $ary[1].  $ary[2];
		if ($ary[0] == '' ||  $ary[1] == '' || $ary[2] == '' || mb_strlen($ary[0]) != 4 || 
				!AppCheckUtil::checkMoji($temp, $errorMessages, $typeNm, $result,
						$data, CON_CHK_HALF_DIGIT, 10, false, false, $elementsIdx)) {
			// 日付時間を入力してください。
			if ($elementsIdx == '0') {
				$errorMessages[$data] = '『' . $typeNm . '』は日付時間を入力してください。';
			} else {
				$errorMessages[$data] = 'Please input Date Format "' . $typeNm . '"';
			}
			return false;
		}
		if (!checkdate($ary[1], $ary[2], $ary[0])) { 
			// 日付時間を入力してください。
			if ($elementsIdx == '0') {
				$errorMessages[$data] = '『' . $typeNm . '』は日付時間を入力してください。';
			} else {
				$errorMessages[$data] = 'Please input Date Format "' . $typeNm . '"';
			}
			return false;
		}
		// 時間をチェック
		$aryB = explode(':', $aryA[1], 3);
		$temp = array();
		$temp[$data] =  $aryB[0] .  $aryB[1].  $aryB[2];
		if ($aryB[0] == '' ||  $aryB[1] == '' || $aryB[2] == '' || mb_strlen($aryB[0]) != 2 || 
			mb_strlen($aryB[1]) != 2 || mb_strlen($aryB[2]) != 2 || 
				!AppCheckUtil::checkMoji($temp, $errorMessages, $typeNm, $result,
						$data, CON_CHK_HALF_DIGIT, 10, false, false, $elementsIdx) ) {
			// 日付時間を入力してください。
			if ($elementsIdx == '0') {
				$errorMessages[$data] = '『' . $typeNm . '』は日付時間を入力してください。';
			} else {
				$errorMessages[$data] = 'Please input Date Format "' . $typeNm . '"';
			}
			return false;
		}


		if (''!= $vars[$data]) {
			$vars[$data] = sprintf("%04d", $ary[0]) . 
										'/' . sprintf("%02d", $ary[1]) . 
										'/' . sprintf("%02d", $ary[2]) .
										' ' . sprintf("%02d", $aryB[0]) .
										':' . sprintf("%02d", $aryB[1]) . 
										':' . sprintf("%02d", $aryB[2]);
		}
		return true;
	}


    /**
     * 指定された大分類コードをチェックする。（DBデータから作成したELEMENTS使用）
     * <p>
     * @param  vars          値の入っている配列
	 * @param  errorMessages エラーエリア
	 * @param  typeNm        大分類項目日本語名
	 * @param  result        true、false 
	 * @param  lrgdata       大分類項目名
	 * @param  codeName      ELEMETNTSコード名
	 * @param  inputCheck    true:未入力はエラー
	 * @param  elementsIdx   0（日本語）,1（英語）を指定する。
	 * @param  indelkbn     '1'削除を含む、'2'削除を含まない
	 * @return チェック結果  true、false
     */	
	static function checkLrgCodeValue(&$vars, &$errorMessages, $typeNm, $result,
							$lrgdata, $codeName, $inputCheck, $elementsIdx = '0', $indelkbn) {
		global $ELEMENTS,$AppDbCd;

		// 配列は検索のチェックボックスでしか使わないのでチェックしない。
		if (!empty($vars[$lrgdata]) && is_array($vars[$lrgdata])) { 
			return $result;
		}

		// 未入力をエラーとするかしないかの切り分け（未入力時は処理終了）
		if ('' == $vars[$lrgdata] ) {
			if ($inputCheck == true) { // 未入力をチェック
				// ?を入力してください。
				if ($elementsIdx == '0') {
					$errorMessages[$lrgdata] = '『' . $typeNm . '』を入力してください。';
				} else {
					$errorMessages[$lrgdata] = 'Please input "' . $typeNm . '"';
				}
				return false;
			}
			return true;
		}
		$AppDbCd->getLrgElements($codeName, $vars[$lrgdata]);

		if (isset($ELEMENTS[$codeName]['lrg'][$vars[$lrgdata]]) && 
			($indelkbn == '1' || ($indelkbn == '2' && $ELEMENTS[$codeName]['lrg'][$vars[$lrgdata]][2] == ''))) { // 大分類がある場合
			return $result;
		}
		// コード値がない場合
		if ($elementsIdx == '0') {
			$errorMessages[$lrgdata] = '『' . $typeNm . '』の入力形式に誤りがあります。';
		} else {
			$errorMessages[$lrgdata] = 'The mistake is found in the input form of the "' . $typeNm . '".';
		}
		return false;
	}

    /**
     * 指定された中分類コードをチェックする。（DBデータから作成したELEMENTS使用）
     * <p>
     * @param  vars          値の入っている配列
	 * @param  errorMessages エラーエリア
	 * @param  typeNm        大分類項目日本語名
	 * @param  result        true、false 
	 * @param  lrgdata       大分類項目名
	 * @param  middata       中分類項目名
	 * @param  codeName      ELEMETNTSコード名
	 * @param  inputCheck    true:未入力はエラー
	 * @param  elementsIdx   0（日本語）,1（英語）を指定する。
	 * @param  indelkbn     '1'削除を含む、'2'削除を含まない
	 * @return チェック結果  true、false
     */	
	static function checkMidCodeValue(&$vars, &$errorMessages, $typeNm, $result,
							$lrgdata, $middata, $codeName, $inputCheck, $elementsIdx = '0', $indelkbn) {
		global $ELEMENTS,$AppDbCd;

		// 配列は検索のチェックボックスでしか使わないのでチェックしない。
		if (!empty($vars[$lrgdata]) && is_array($vars[$lrgdata])) { 
			return $result;
		}
		if (!empty($vars[$middata]) && is_array($vars[$middata])) { 
			return $result;
		}

		// 未入力をエラーとするかしないかの切り分け（未入力時は処理終了）
		if ('' == $vars[$middata] ) {
			if ($inputCheck == true) { // 未入力をチェック
				// ?を入力してください。
				if ($elementsIdx == '0') {
					$errorMessages[$middata] = '『' . $typeNm . '』を入力してください。';
				} else {
					$errorMessages[$middata] = 'Please input "' . $typeNm . '"';
				}
				return false;
			}
			return true;
		}
		$AppDbCd->getMidElements($codeName, $vars[$lrgdata], $vars[$middata]);

		if (isset($ELEMENTS[$codeName]['mid'][$vars[$lrgdata]][$vars[$middata]]) && 
			($indelkbn == '1' || ($indelkbn == '2' && $ELEMENTS[$codeName]['mid'][$vars[$lrgdata]][$vars[$middata]][2] == ''))) { // 中分類がある場合
			return $result;
		}
		// コード値がない場合
		if ($elementsIdx == '0') {
			$errorMessages[$middata] = '『' . $typeNm . '』の入力形式に誤りがあります。';
		} else {
			$errorMessages[$middata] = 'The mistake is found in the input form of the "' . $typeNm . '".';
		}
		return false;
	}

    /**
     * 指定された小分類コードをチェックする。（DBデータから作成したELEMENTS使用）
     * <p>
     * @param  vars          値の入っている配列
	 * @param  errorMessages エラーエリア
	 * @param  typeNm        大分類項目日本語名
	 * @param  result        true、false 
	 * @param  lrgdata       大分類項目名
	 * @param  middata       中分類項目名
	 * @param  smldata       小分類項目名
	 * @param  codeName      ELEMETNTSコード名
	 * @param  inputCheck    true:未入力はエラー
	 * @param  elementsIdx   0（日本語）,1（英語）を指定する。
	 * @param  indelkbn     '1'削除を含む、'2'削除を含まない
	 * @return チェック結果  true、false
     */	
	static function checkSmlCodeValue(&$vars, &$errorMessages, $typeNm, $result,
							$lrgdata, $middata, $smldata, $codeName, $inputCheck, $elementsIdx = '0', $indelkbn) {
		global $ELEMENTS,$AppDbCd;

		// 配列は検索のチェックボックスでしか使わないのでチェックしない。
		if (!empty($vars[$lrgdata]) && is_array($vars[$lrgdata])) { 
			return $result;
		}
		if (!empty($vars[$middata]) && is_array($vars[$middata])) { 
			return $result;
		}
		if (!empty($vars[$smldata]) && is_array($vars[$smldata])) { 
			return $result;
		}

		// 未入力をエラーとするかしないかの切り分け（未入力時は処理終了）
		if ('' == $vars[$smldata] ) {
			if ($inputCheck == true) { // 未入力をチェック
				// ?を入力してください。
				if ($elementsIdx == '0') {
					$errorMessages[$smldata] = '『' . $typeNm . '』を入力してください。';
				} else {
					$errorMessages[$smldata] = 'Please input "' . $typeNm . '"';
				}
				return false;
			}
			return true;
		}
		$AppDbCd->getSmlElements($codeName, $vars[$lrgdata], $vars[$middata], $vars[$smldata]);

		if (isset($ELEMENTS[$codeName]['sml'][$vars[$lrgdata]][$vars[$middata]][$vars[$smldata]]) && 
			($indelkbn == '1' || ($indelkbn == '2' && $ELEMENTS[$codeName]['sml'][$vars[$lrgdata]][$vars[$middata]][$vars[$smldata]][2] == ''))) { // 小分類がある場合
			return $result;
		}
		// コード値がない場合
		if ($elementsIdx == '0') {
			$errorMessages[$smldata] = '『' . $typeNm . '』の入力形式に誤りがあります。';
		} else {
			$errorMessages[$smldata] = 'The mistake is found in the input form of the "' . $typeNm . '".';
		}
		return false;
	}

}
//  =============================================================
//  2020 kaz PHP自動作成お助けTOOL. End
//  修正BSDライセンス。
//  =============================================================

?>
