<?php
//  =============================================================
//  2020 kaz PHP自動作成お助けTOOL. Start
//  修正BSDライセンス。
//  =============================================================
class AppHtmlUtil
{

    /**
     * 指定されたコードのHTMLSelect文字列を作成する。
     * <p>
     * @param  emts    コード配列
	 * @param  indata 入力値
	 * @param  name  name
	 * @param  dflt  "▼選択してください"を設定する。設定しない場合""を指定する。
	 * @param  elementsIdx  0（日本語）,1（英語）を指定する。
	 * @return HTMLOption文字
     */	
	static function getHTMLSelect($emts, $indata, $name, $dflt, $elementsIdx = '0') {
		$result = "<select name=\"" . $name . "\" id=\"" . $name .  "\" ";
		$result .= " >\n";
		if ($dflt != '') {
			$result .= "<option value=\"\">" . $dflt  . "</option>\n";
		}
		foreach ($emts  as $key => $val) {
			$selected = ((String)$indata == (String)$key ? "selected" : "");
			$result .= "<option value='" . $key . "' " . $selected . ">" . $val[$elementsIdx] . "</option>\n";
		}
		$result .= "</select>\n";
		return $result;
	}
		
    /**
     * 指定されたコードのHTMLRadio文字列を作成する。
     * <p>
     * @param  emts    コード名称
	 * @param  indata 入力値
	 * @param  name  name
	 * @param  dflt  "指定なし"を設定する。設定しない場合""を指定する。
	 * @param  elementsIdx  0（日本語）,1（英語）を指定する。
	 * @param  su  1行のITEM数
	 * @param  addItemNm  コード名の先頭にこの項目名を付加する
	 * @return HTMLRadio文字
     */	
	static function getHTMLRadio($emts, $indata, $name, $dflt, $elementsIdx = '0', $su = 1, $addItemNm = '') {
		$indata = ($indata==null?"":$indata);
		$result = "";
		$i = 0;
		foreach ($emts  as $key => $val) {
			$i++;
			$checked = ((String)$indata == (String)$key ? "checked" : "");
			$result .= "<input type=\"radio\" name=\"" . $name .  "\"  value=\"" . $key . "\" id=\"" . "radio_" . $name . $i . "\" " . $checked . " />\n";
			$result .= "<label for=\"" .  "radio_" . $name . $i . "\">" . $addItemNm . ($addItemNm =='' ? '':'を') . $val[$elementsIdx] . "</label>" . ((($i % $su) == 0) ? "<br>" : "") ."\n";
		}
		if ($dflt != '') {
			$checked = ((String)$indata == ""?"checked":"");
			$result .= "<input type=\"radio\" name=\"" . $name .  "\"  value=\"\" id=\"" . "radio_" . $name . "\" " . $checked . " />\n";
			$result .= "<label for=\"" .  "radio_" . $name . "\">" . $dflt . "</label>\n";
		}
		return $result;
	}
		
    /**
     * 指定されたコードのHTMLCheckBox文字列を作成する。
     * <p>
     * @param  emts    コード名称
	 * @param  indata 入力値
	 * @param  name  name
	 * @param  elementsIdx  0（日本語）,1（英語）を指定する。
	 * @param  su  1行のITEM数
	 * @return HTMLCheckBox文字
     */	
	static function getHTMLCheckBox($emts, $indata, $name, $elementsIdx = '0', $su = 5) {
		$indata = ($indata==null?"":$indata);

		$result = "";
		$i = 0;
		foreach ($emts  as $key => $val) {
			$i++;
			if(is_array($indata)) { // 配列
				$checked = (arryVal($indata,(String)$key) <>"" ? "checked" : "");
			} else {
				$checked = ((String)$indata == (String)$key ? "checked" : "");
			}

			$result .= "<input type=\"checkbox\" name=\"" . $name .  "\"  value=\"" . $key . "\" id=\"" . "check_" . $name . $i . "\" " . $checked . " />\n";
			$result .= "<label for=\"" .  "check_" . $name . $i . "\">" . $val[$elementsIdx] . "</label>" . ((($i % $su) == 0) ? "<br>" : "") ."\n";
		}
		return $result;
	}
		
    /**
     * 指定されたコードのHTMLCheckBoxの文字列のみを作成する。
     * <p>
     * @param  emts    コード名称
	 * @param  indata 入力値
	 * @param  elementsIdx  0（日本語）,1（英語）を指定する。
	 * @return HTMLCheckBoxの文字列のみ
     */	
	static function getHTMLCheckBoxDispStr($emts, $indata, $elementsIdx = '0') {
		$indata = ($indata==null?"":$indata);

		$result = "";
		$i = 0;
		foreach ($emts  as $key => $val) {
			$i++;
			if(is_array($indata)) { // 配列
				if (arryVal($indata,(String)$key) <>"") {
					if ($elementsIdx == '0') {
						$result .= $val[$elementsIdx] . "、";
					} else {
						$result .= $val[$elementsIdx] . ", ";
					}
				}
			} else {
				if ($indata == $key) {
					if ($elementsIdx == '0') {
						$result .= $val[$elementsIdx] . "、";
					} else {
						$result .= $val[$elementsIdx] . ", ";
					}
				}
			}
		}
		if ($result == "") {
			if ($elementsIdx == '0') {
				$result = "全て";
			} else {
				$result = "AllSelected";
			}
		} else {
			if ($elementsIdx == '0') {
				$result = mb_substr($result,0, mb_strlen($result) - mb_strlen("、"));
			} else {
				$result = mb_substr($result,0, mb_strlen($result) - mb_strlen(", "));
			}
		}
		return $result;
	}


// JavaScript用の中小分類配列を$ELEMENTSから作成する。
//　作成例：
//　　<script language="JavaScript">
//　　<!--
//　　var ary_category = new Array();
//　　// 中分類の配列：$ELEMENTS[$elename]['mid']がない場合は作成しない。
//　　ary_category['mid'] = new Array();
//　　ary_category['mid']['A'] = new Array();
//　　ary_category['mid']['A']['1'] = new Array('野菜','yasai', '');
//　　// 小分類の配列：$ELEMENTS[$elename]['sml']がない場合は作成しない。
//　　ary_category['sml'] = new Array();
//　　ary_category['sml']['A'] = new Array();
//　　ary_category['sml']['A']['1'] = new Array();
//　　ary_category['sml']['A']['1']['a'] = new Array('キャベツ','kyabetu', '');
//　　ary_category['sml']['A']['1']['b'] = new Array('ピーマン','pi-man', 'del');
//　　-->
//　　</script>
static function creJSvarCategory($elename) {
	global $ELEMENTS;
	
	$str = '';
	$str = $str . "<script language='JavaScript'>\n";
	$str = $str . "<!--\n";
		$str = $str . "var " . $elename . " = new Array();\n";
		if (!empty($ELEMENTS[$elename]['mid']) && is_array($ELEMENTS[$elename]['mid'])) {
			$str = $str . "// 中分類)の配列\n";
			$str = $str . $elename . "['mid'] = new Array();\n";
			foreach( $ELEMENTS[$elename]['mid'] as $key1 => $vals1 ){
				$str = $str . $elename . "['mid']['" . $key1 . "'] = new Array();\n";
				foreach( $vals1 as $key2 => $vals2 ){
					$str = $str . $elename . "['mid']['" . $key1 . "']['" . $key2 . "'] = new Array('" . $vals2[0] . "','" . $vals2[1] . "','" . $vals2[2] . "');\n";

				}
			}
		}
		if (!empty($ELEMENTS[$elename]['sml']) && is_array($ELEMENTS[$elename]['sml'])) {
			$str = $str . "// 小分類の配列\n";
			$str = $str . $elename . "['sml'] = new Array();\n";
			foreach( $ELEMENTS[$elename]['sml'] as $key1 => $vals1 ){
				$str = $str . $elename . "['sml']['" . $key1 . "'] = new Array();\n";
				foreach( $vals1 as $key2 => $vals2 ){
					$str = $str . $elename . "['sml']['" . $key1 . "']['" . $key2 . "'] = new Array();\n";
					foreach( $vals2 as $key3 => $vals3 ){
						$str = $str . $elename . "['sml']['" . $key1 . "']['" . $key2 . "']['" . $key3 . "'] = new Array('" . $vals3[0] . "','" . $vals3[1] . "','" . $vals3[2] . "');\n";

					}
				}
			}
		}
	
	$str = $str . "-->\n";
	$str = $str . "</script>\n";
	
	return $str;
}

// エレメントをajax経由で作成するか否かのJavaScript用配列。
//　@param $vals getAryLrgmidsmlAjaxKbnメソッドで取得した配列
//　作成例：
//　　<script language="JavaScript">
//　　<!--
//　　var ary_lrgmidsml_ajaxKbn = new Array();
//　　ary_lrgmidsml_ajaxKbn['ary_lrgmidsml_category'] = 'ajax';
//　　ary_lrgmidsml_ajaxKbn['ary_lrgmidsml_biztype'] = '';
//　　-->
//　　</script>
static function creJSvarAryLrgmidsmlAjaxKbn($vals) {
	
	$str = '';
	$str = $str . "<script language='JavaScript'>\n";
	$str = $str . "<!--\n";
	$str = $str . "var ary_lrgmidsml_ajaxKbn = new Array();\n";
	foreach( $vals as $key => $val ){
		$str = $str . "ary_lrgmidsml_ajaxKbn['" . $key . "'] = '" . $val . "';\n";
	}
	$str = $str . "-->\n";
	$str = $str . "</script>\n";
	
	return $str;
}

    /**
     * 指定された大分類コードのHTMLSelect文字列を作成する。（DBデータから作成したELEMENTS使用）
     * <p>
     * @param  emts    コード配列
	 * @param  indataLrg 大分類入力値
	 * @param  name  name
	 * @param  dflt  "▼選択してください"を設定する。設定しない場合""を指定する。
	 * @param  elementsIdx  0（日本語）,1（英語）を指定する。
	 * @param  plus onchengeなどの文字列。selectに追加される。
	 * @param  indelkbn  '1'削除を含む、'2'削除を含まない
	 * @return HTMLOption文字
     */	
	static function getHTMLSelectLrgPlus(&$emts, $indataLrg, $name, $dflt, $elementsIdx = '0', $plus, $indelkbn) {
		$result = "<select name=\"" . $name . "\" id=\"" . $name .  "\" ";
		$result .= $plus . " >\n";
		if ($dflt != '') {
			$result .= "<option value=\"\">" . $dflt  . "</option>\n";
		}

		foreach ($emts['lrg']  as $key => $val) {
			if ($indelkbn == '1' || ($indelkbn == '2' && $val[2] == '')) {
				$selected = ((String)$indataLrg == (String)$key ? "selected" : ""); // 大分類が同じ
				$result .= "<option value='" . $key . "' " . $selected . ">" . $val[$elementsIdx] . "</option>\n";
			}
		}
		$result .= "</select>\n";
		return $result;
	}


    /**
     * 指定された中分類コードのHTMLSelect文字列を作成する。（DBデータから作成したELEMENTS使用）
     * <p>
     * @param  emts    コード配列
	 * @param  indataLrg 大分類入力値
	 * @param  indataMid 中分類入力値
	 * @param  name  name
	 * @param  dflt  "▼選択してください"を設定する。設定しない場合""を指定する。
	 * @param  elementsIdx  0（日本語）,1（英語）を指定する。
	 * @param  plus onchengeなどの文字列。selectに追加される。
	 * @param  indelkbn  '1'削除を含む、'2'削除を含まない
	 * @return HTMLOption文字
     */	
	static function getHTMLSelectMidPlus(&$emts, $indataLrg, $indataMid, $name, $dflt, $elementsIdx = '0', $plus, $indelkbn) {
		$result = "<select name=\"" . $name . "\" id=\"" . $name .  "\" ";
		$result .= $plus . " >\n";
		if ($dflt != '') {
			$result .= "<option value=\"\">" . $dflt  . "</option>\n";
		}

		foreach ($emts['mid']  as $key1 => $vals1) {
			if ($key1 == $indataLrg) { // 大分類が同じ
				foreach ($vals1  as $key2 => $val2) { // 中分類
					if ($indelkbn == '1' || ($indelkbn == '2' && $val2[2] == '')) {
						$selected = ((String)$indataMid == (String)$key2 ? "selected" : ""); // 中分類が同じ
						$result .= "<option value='" . $key2 . "' " . $selected . ">" . $val2[$elementsIdx] . "</option>\n";
					}
				}
			}
		}
		$result .= "</select>\n";
		return $result;
	}


    /**
     * 指定された小分類コードのHTMLSelect文字列を作成する。（DBデータから作成したELEMENTS使用）
     * <p>
     * @param  emts    コード配列
	 * @param  indataLrg 大分類入力値
	 * @param  indataMid 中分類入力値
	 * @param  indataSml 小分類入力値
	 * @param  name  name
	 * @param  dflt  "▼選択してください"を設定する。設定しない場合""を指定する。
	 * @param  elementsIdx  0（日本語）,1（英語）を指定する。
	 * @param  plus onchengeなどの文字列。selectに追加される。
	 * @param  indelkbn  '1'削除を含む、'2'削除を含まない
	 * @return HTMLOption文字
     */	
	static function getHTMLSelectSmlPlus(&$emts, $indataLrg, $indataMid, $indataSml, $name, $dflt, $elementsIdx = '0', $plus, $indelkbn) {
		$result = "<select name=\"" . $name . "\" id=\"" . $name .  "\" ";
		$result .= $plus . " >\n";
		if ($dflt != '') {
			$result .= "<option value=\"\">" . $dflt  . "</option>\n";
		}

		foreach ($emts['sml']  as $key1 => $vals1) {
			if ($key1 == $indataLrg) { // 大分類が同じ
				foreach ($vals1  as $key2 => $vals2) {
					if ($key2 == $indataMid) { // 中分類が同じ
						foreach ($vals2  as $key3 => $val3) { // 小分類
							if ($indelkbn == '1' || ($indelkbn == '2' && $val3[2] == '')) {
								$selected = ((String)$indataSml == (String)$key3 ? "selected" : ""); // 小分類が同じ
								$result .= "<option value='" . $key3 . "' " . $selected . ">" . $val3[$elementsIdx] . "</option>\n";
							}
						}
					}
				}
			}
		}
		$result .= "</select>\n";
		return $result;
	}


}
//  =============================================================
//  2020 kaz PHP自動作成お助けTOOL. End
//  修正BSDライセンス。
//  =============================================================

?>
